/*****************************************************************************/
/*
                                  HTAdmin.h

Function prototypes for HTAdmin module.

*/
/*****************************************************************************/

#ifndef HTADMIN_H_LOADED
#define HTADMIN_H_LOADED 1

#include "wasd.h"

/**************/
/* structures */
/**************/

struct HTAdminTaskStruct
{
   struct HTAdminTaskStruct  *HTAdminTaskPtr;

   boolean  /* */
            BriefList,
            /* */
            ParseInUse;

   int  /* */
        FileCount,
        /* */
        FileNameLength,
        /* */
        RecordCount,
        /* */
        UserCount,
        /* */
        UserListCount,
        /* */
        UserListLength;

   char  /* */
         AuthFileName [64],
         /* */
         AuthFileSpec [64],
         /* */
         ExpandedFileName [256],
         /* */
         ResultantFileName [256];

   char  /* */
         *UserListPtr;

   struct AuthHtRecordStruct  AuthHtRecord;

   /* RMS structures */
   struct FAB  FileFab;
   struct RAB  FileRab;
   struct NAM  FileNam;
   struct XABDAT  FileXabDat;
   struct XABFHC  FileXabFhc;
   struct FAB  SearchFab;
   struct NAM  SearchNam;

   /* pointer to function, used for specifying the next task */
   void (*NextTaskFunction)(struct RequestStruct*);
};

/**************/
/* structures */
/**************/

HTAdminBegin (struct RequestStruct*, void*);
HTAdminCacheResetEntry (struct AuthCacheRecordStruct*,
                        struct AuthCacheRecordStruct*);
char* HTAdminCanString (struct RequestStruct*, unsigned long, boolean);
HTAdminDatabaseBegin (struct RequestStruct*);
HTAdminDatabaseEnd (struct RequestStruct*);
HTAdminDatabaseSearch (struct RequestStruct*);
HTAdminDatabaseSearchAst (struct FAB*); 
HTAdminDatabaseUsersBegin (struct RequestStruct*, char*);
HTAdminDatabaseUsersEnd (struct RequestStruct*);
HTAdminDatabaseUsersList (struct RequestStruct*);
HTAdminDatabaseUsersListSort (struct RequestStruct*);
HTAdminDatabaseUsersNext (struct RequestStruct*);
HTAdminDatabaseUsersNextAst (struct RAB*); 
HTAdminEnd (struct RequestStruct*);
HTAdminListUsersBegin (struct RequestStruct*, char*);
HTAdminListUsersEnd (struct RequestStruct*);
HTAdminListUsersList (struct RequestStruct*);
HTAdminListUsersListSort (struct RequestStruct*);
HTAdminListUsersNext (struct RequestStruct*);
HTAdminListUsersNextAst (struct RAB*); 
HTAdminModifyUser (struct RequestStruct*, boolean, char*, char*, char*,
                   char*, char*, char*, char*, char*, char*, char*);
HTAdminModifyUserForm (struct RequestStruct*, boolean, char*, char*);
HTAdminPasswordChange (struct RequestStruct*, char*, char*, char*);
HTAdminPasswordChangeForm (struct RequestStruct*);
HTAdminResetCacheEntry (struct RequestStruct*, char*, char*);

#endif /* HTADMIN_H_LOADED */

/*****************************************************************************/

