/*****************************************************************************/
/*
                                  IsMap.h
*/
/*****************************************************************************/

#ifndef ISMAP_H_LOADED
#define ISMAP_H_LOADED 1

#include "wasd.h"

/**************/
/* structures */
/**************/

struct IsMapTaskStruct
{
   boolean  /* SYSUAF authenticated user has been checked to have access */
            AuthVmsUserHasAccess;

   int  /* */
        FileNameLength,
        /* character number currently being parsed (for error information) */
        IsMapCharNumber,
        /* line number in current line (for error information) */
        IsMapLineNumber,
        /* buffer for most recent task status */
        TaskStatusBuffer;

   double  /* keeps track of closest 'point x,y' (if any) */
           IsMapClosestPoint,
           /* stores the numeric equivalent of the browser x,y click point */
           IsMapClickCoord [2];

   char  /* */
         FileName [256],
         /* */
         ReadBuffer [256];

   /* RMS structures */
   struct FAB  FileFab;
   struct RAB  FileRab;

   /* pointer to function, used for specifying the next task */
   void (*NextTaskFunction)(struct RequestStruct*);
};

/***********************/
/* function prototypes */
/***********************/

IsMapBegin (struct RequestStruct*, void*, char*);
IsMapEnd (struct RequestStruct*);
IsMapNextRecordAST (struct RAB*);
IsMapParseLine (struct RequestStruct*);
IsMapExplainError (struct RequestStruct*, char*, char*, int);

#endif /* ISMAP_H_LOADED */

/*****************************************************************************/
